﻿(function () {

    "use strict";

    angular.module("enrServicesModule")
           .factory("participationCalculator", ["officeJsonRegionFilter", "regionPropertiesParser", "$filter", "regionsJsonParser", function (officeJsonRegionFilter, regionPropertiesParser, $filter, regionsJsonParser) {

               return {
                   isOfficesRegionParticipating: function (officeCategoryJson, regionProperties) {
                       var result = false;

                       var doesRegionInfoExist = regionsJsonParser.validOfficesRegionsJsonExist(officeCategoryJson);

                       if (doesRegionInfoExist) {
                           var filteredRegionNodes = officeJsonRegionFilter.getRegionNodes(officeCategoryJson, regionProperties);

                           // If no region information is present, that region is not participating
                           result = filteredRegionNodes.length !== 0;
                       }

                       return result;
                   },

                   isReferendumsRegionParticipatingFromDetailedJson: function (referendumRegionJson) {
                       return regionsJsonParser.validReferendumsDetailsJsonExist(referendumRegionJson);
                   },

                   isReferendumsRegionParticipatingFromSummaryJson: function (referendumSummaryJson, regionProperties) {
                       var regionId = regionPropertiesParser.getRegionPrimaryId(regionProperties, false, true);
                       var regionNodes = $filter("filter")(referendumSummaryJson.Regions.Region, { FIPS: regionId.toString() }, true);
                       var regionNode = regionNodes.length > 0 ? regionNodes[0] : undefined;

                       return regionNode !== undefined && regionNode !== null &&
                              regionNode.Referendums !== undefined && regionNode.Referendums !== null &&
                              regionNode.Referendums.ALL_POSITIVE_RESULTS !== undefined && regionNode.Referendums.ALL_NEGATIVE_RESULTS !== undefined && 
                              regionNode.Referendums.ALL_POSITIVE_RESULTS !== null && regionNode.Referendums.ALL_NEGATIVE_RESULTS !== null;
               }
           };
           }]);

}());